
Core - Bug # 64916

Status: Resolved Priority: Must have
Author: Markus Klein Category: Backend API
Created: 2015-02-06 Assigned To: Markus Klein
Updated: 2015-02-10 Due date:
TYPO3 Version: 7
PHP Version:
Complexity: hard
Is Regression: No
Sprint Focus: Stabilization Sprint
Subject: Avoid serialization of some members of ContentObjectRenderer
Description

UserInternalContentObject is trying to serialize ContentObjectRenderer.
This leads to severe issues also uses lots of memory.

If you set up a page like this

page = PAGE
page.10 < styles.content.get
page.20 < plugin.tx_felogin_pi1

Install sysext:felogin and add static templates for CSC and felogin!

Add a "text w/image" CE to the page and add at least one image.

you'll get an Exception in FE: Serialization of closure not possible.

(In order to see the Exception you need to set the application context to Development and select the Development-preset in Install
Tool.)

The reason is that if the Core is not installed via composer, a closure is registered in the SignalSlotDispatcher.
For some reason, when serializing ContentObjectRenderer, also SignalSlotDispatcher is serialized, which leads to this exception.

The solution is to remove the "hard-wires" between ContentObjectRenderer and TSFE and File(Reference).

Related issues:
related to Core - Bug # 64376: Class aliases not respected in certain situations Resolved 2015-01-20

Associated revisions
Revision 4bbdf772 - 2015-02-10 14:49 - Helmut Hummel

[BUGFIX] Exclude some vars from serialization

This voids the serialization of TSFE and currentFile with the
ContentObjectRenderer in UserInternalContentObject.

Releases: master
Resolves: #64916
Change-Id: I2ce74ee0960d33b39dec51c2f6150d79a113d5fe
Reviewed-on: http://review.typo3.org/36723
Reviewed-by: Markus Klein <klein.t3@reelworx.at>
Tested-by: Markus Klein <klein.t3@reelworx.at>
Reviewed-by: Alexander Opitz <opitz.alexander@googlemail.com>
Tested-by: Alexander Opitz <opitz.alexander@googlemail.com>

History
#1 - 2015-02-06 20:50 - Gerrit Code Review
- Status changed from Accepted to Under Review

Patch set 1 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/36723

#2 - 2015-02-06 21:53 - Gerrit Code Review

Patch set 2 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/36723

#3 - 2015-02-10 11:34 - Markus Klein
- Description updated

#4 - 2015-02-10 12:02 - Gerrit Code Review

Patch set 3 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/36723

#5 - 2015-02-10 13:33 - Gerrit Code Review

Patch set 4 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/36723

#6 - 2015-02-10 14:04 - Markus Klein
- Subject changed from Avoid serialization of TSFE with ContentObjectRenderer to Avoid serialization of some members of ContentObjectRenderer
- Description updated

#7 - 2015-02-10 14:25 - Markus Klein
- Description updated

#8 - 2015-02-10 15:00 - Helmut Hummel
- Status changed from Under Review to Resolved
- % Done changed from 0 to 100

Applied in changeset commit:4bbdf7725b06ce2ed89d95217b6371ec40a0667a.
